function a = Honorm(T,type)
% This function is used to caculate norm of high order tensor
%
% Argument:
%         T      -Input tensor;
%         type   -the type of norm, such as 1-norm, 2-norm;
%                   
% Returns:
%         a      -The caculated value.
%
% see also: strcmp, class, sum, size

% Author:   Aimery Kong
%           29/10/2010
%%

if nargin < 2
    type = 2;
end
if strcmp(class(type),'char')
    type = 2;
end
I = size(T);
T = tensor2matrix(T,1);
T = abs(T).^type;
a = sum(sum(T));
%{
if type == 1
    a = abs(T);
    for i = 2:length(I)
        a = sum(a);
    end
else
    a = sum(T.^type);
    for i = 2:length(I)
        a = sum(a);
    end
end
%}