clear all;close all;clc;
fid = fopen('Exp_GFDA_Random_TestOnORL.txt','w');
fclose(fid);

MAXLOOP = 400;
MAXIteration = 1;
ratio = 0.99;
e = 10^-5;
ProjDim = [7 7]; % !! When reset the ProjDim, remember to reset the Tt below!!!
Show2D_Proj = 0; % Show 2D projection points of the samples or not? 0 for no, 1 for yes.
ShowTips = 0;
C = 40;  % The number of classes, and the whole is 40.
TrainNum = 3;

%% Input Samples for training
% Input the data from ORL_2D.mat
ERROR = 0;
TOTAL = 0;
if ShowTips == 1
    disp('Start -- input training samples, please wait...');
end

for TrainNum = 3:1:5
    minimumER = 1;
    minRatio = 0;
    minx = 0;
    miny = 0;
    for ratio = 0.98:0.002:0.998
        for x = 6:12
            for y = 6:12
                ProjDim=[x,y];
                Invalid = 0;                
                %%                
                Time = 0;
                AverageErrorRate = 0;
                LOOP = 0;
                for Iteration = 1:MAXIteration
                    fprintf('%4f %3d %3d %3d\n',ratio,x,y,Iteration);
                    clear T Test Tall
                    load ORL_2D.mat;
                    Ttmp = T;
                    nTest = 1;
                    nTrain = 1;
                    num = 1;
                    clear T;
                    for i = 1:C
                        valid = randperm(size(Ttmp{1},3));
                        n = 1;
                        for j = 1:size(Ttmp{1},3)
                            if j <= TrainNum
                                T{num}(:,:,n) = Ttmp{num}(:,:,valid(j));
                                n = n+1;
                                TrainName{nTrain}=Name{i};
                                nTrain = nTrain + 1;
                            else
                                Test(:,:,nTest) = Ttmp{num}(:,:,valid(j));
                                TestName{nTest}=Name{i};
                                nTest = nTest + 1;
                            end
                        end
                        N(num) = size(T{num},3);
                        num = num+1;
                    end
                    nTest = nTest-1;
                    nTrain = nTrain-1;
                    clear Ttmp;
                    
                    Tall = T{1};
                    num = N(1)+1;
                    for i =2:C
                        for j = 1:N(i)
                            Tall(:,:,num) = T{i}(:,:,j);
                            num = num+1;
                        end
                    end
                    Ntotal = sum(N);
                    if ShowTips == 1
                        disp('Finish -- input the training samples.');
                    end
                    t1 = cputime;
                    
                    %% HOSVD used for dimensionality reduction
                    t_start = cputime;
                    
                    [Core,U] = HOSVD(Tall,[ratio,ratio,1]);
                    
                    Tall = U{3}*tensor2matrix(Core,3);
                    %clear Core;
                    Dimnew = [size(U{1},2) size(U{2},2)];
                    Tall = matrix2tensor(Tall,[Dimnew Ntotal],3);
                    clear Ttmp;
                    Mglobal = mean(Tall,3);
                    
                    St = 1;
                    En = 1;
                    for i = 1:C
                        En = St+N(i)-1;
                        T{i} = Tall(:,:,St:En);
                        St = En+1;
                        M{i} = mean(T{i},3);
                    end
                    
                    %% initialization and preprocessing
                    % Initialize Ui
                    if ShowTips == 1
                        disp('Initialize the Fisher projectors, please wait...');
                    end
                    for i = 1:length(ProjDim)
                        w{i} = ones(size(Mglobal,i),ProjDim(i));
                        w{i} = w{i}/norm(w{i},2);
                        if ProjDim(i) > size(Mglobal,i)
                            Invalid = 1;
                            x = size(Mglobal,1); % w{1}
                            y = size(Mglobal,2); % w{2}
                            break;
                        end
                    end
                    if Invalid == 1
                        break;
                    end
                    
                    %% Training Process
                    loop = 1;
                    wpre = w;
                    ModeCount = length(ProjDim);
                    ConvergeYN = zeros(ModeCount,1);
                    if ShowTips == 1
                        disp('Training the Fisher projectors, please wait...');
                    end
                    while loop < MAXLOOP && sum(ConvergeYN) < ModeCount
                        for n = 1:ModeCount
                            if ConvergeYN(n) == 1
                                continue;
                            end
                            Sb = 0;
                            Sw = 0;
                            tmpKron = 1;
                            for k = ModeCount:-1:1
                                if k ~= n
                                    tmpKron = kron(tmpKron,w{k}');
                                end
                            end
                            
                            for c = 1:C
                                tmp = tensor2matrix(M{c}-Mglobal,n)*tmpKron';
                                Sb = Sb + tmp*tmp';
                                for i = 1:N(c)
                                    tmp = tensor2matrix(T{c}(:,:,i)-M{c},n)*tmpKron';
                                    Sw = Sw + tmp*tmp';
                                end
                            end
                            
                            S = pinv(Sw)*Sb;
                            [w{n},S,V] = svd(S);
                            try
                                w{n} = w{n}(:,1:ProjDim(n));
                            catch
                                Invalid = 1;
                                break;
                            end
                            clear S V;
                            if Invalid == 1
                                break;
                            end
                            if  norm(w{n} - wpre{n},'fro') < e
                                ConvergeYN(n) = 1;
                            else
                                wpre{n} = w{n};
                            end
                        end
                        if Invalid == 1
                            break;
                        end
                        
                        % check convergence
                        if sum(ConvergeYN) == ModeCount
                            break;
                        end
                        loop = loop+1;
                    end
                    LooP = loop;
                    t_end = cputime;
                    clear Sw Sb S ConvergeYN wpre n i k j tmpKron c
                    if Invalid == 1
                        break;
                    end
                    if loop < MAXLOOP
                        if ShowTips == 1
                            fprintf('Converge after %d loops.\n\n',loop);
                        end
                    else
                        if ShowTips == 1
                            fprintf('This program may not converge, please reset the parameters.\n');
                        end
                    end
                    if ShowTips == 1
                        fprintf('The training time is about %.4fs.\n',cputime-t1);
                    end
                    
                    %% Clustering Result
                    Tt = Tall;
                    for k =ModeCount:-1:1
                        if ProjDim(k) == 1
                            Tt = Hoprod(Tt,w{k},'vec',k);
                        else
                            Tt = Hoprod(Tt,w{k}','mat',k);
                        end
                    end
                    
                    if Show2D_Proj == 1
                        ColorPanel = {'r','g','b','k','c','m','y'};%
                        StylePanel = {'+','*','^','d','p','h'};%'.','x',
                        
                        ind = 1;
                        for i =1:C
                            for j =1:N(i)
                                color = ColorPanel{mod(i,7)+1};
                                style = StylePanel{mod(i,6)+1};
                                
                                plot(Tt(1,1,ind),Tt(2,1,ind),strcat(color,style));
                                ind = ind+1;
                                hold on;
                            end
                        end
                        title('Clustering Result');
                        hold off;
                    end
                                                            
                    %% Test process
                    Error = 0;
                    if ShowTips == 1
                        fprintf('Start -- input testing samples, please wait...\n\n');
                        fprintf('The number of training samples is %d in every class.\n',TrainNum);
                        fprintf(' %-9s  %14s %8s\n','Test_name','Matching_class','Y/N');
                        fprintf('---------------------------------------\n');
                    end
                    for k = 1:nTest
                        Tmp = Test(:,:,k);
                        I = size(Tmp);
                        for i = ModeCount:-1:1
                            Tmp = (w{i}'*U{i}')*tensor2matrix(Tmp,i);
                            I(i)=size(w{i},2);
                            Tmp = matrix2tensor(Tmp,I,i);
                        end
                        index = 1;
                        minimum = Honorm(Tt(:,:,1)-Tmp,2);
                        for m = 2:Ntotal
                            t = Honorm(Tt(:,:,m)-Tmp,2);
                            if t < minimum
                                index = m;
                                minimum = t;
                            end
                        end
                        if ShowTips == 1
                            fprintf('| %-9s  %-14s ',TestName{k}, TrainName{index});
                        end
                        if not(strcmp(TrainName{index},TestName{k}))
                            Error = Error+1;
                            if ShowTips == 1
                                fprintf('%8s |\n','X');
                            end
                        else
                            if ShowTips == 1
                                fprintf('%8s |\n','Correct!');
                            end
                        end
                        
                        if Show2D_Proj == 1
                            hold on;
                            plot(Tmp(1,1),Tmp(2,1),'rh');
                            hold off;
                        end
                    end
                    if ShowTips == 1
                        fprintf('---------------------------------------\n');
                        fprintf('\nThe error rate is about: %.4f\n',Error/nTest);
                    end
                    Time = Time + t_end-t_start;
                    LOOP = LOOP + LooP;
                    AverageErrorRate = AverageErrorRate + Error/nTest;
                end
                if Invalid == 1
                    break;
                end
                
                if ShowTips == 1
                    fprintf('\n...........................................................');
                end
                Time = Time/MAXIteration;
                AverageErrorRate=AverageErrorRate/MAXIteration;
                LOOP = LOOP/MAXIteration;
                
                fprintf('\nThe average error rate is about: %.4f\n\n',...
                    AverageErrorRate);
                                
                if Invalid == 1
                    %    fid = fopen('Exp_GFDA_Random_TestOnORL.txt','a+');
                    %    str = strcat('TrainNum:',num2str(TrainNum),', ratio:',num2str(ratio),...
                    %        ', [',num2str(x),',',num2str(y),']',', Average error rate:'...
                    %        ,num2str(AverageErrorRate),' --- INVALID!\r\n');
                    %    fprintf(fid,str);
                    %    fclose(fid);
                else
                    fid = fopen('Exp_GFDA_Random_TestOnORL.txt','a+');
                    
                    str = strcat('TrainNum:',num2str(TrainNum),', ratio:',num2str(ratio),...
                        ', Error rate:', num2str(AverageErrorRate), ', Accuracy:',...
                        num2str(1-AverageErrorRate), ', Dim: [',num2str(x),',',num2str(y),']',...
                        ', Time: ', num2str(Time),', loop:',num2str(LOOP),', Time:',num2str(Time),'\r\n');
                    
                    fprintf(fid,str);
                    fclose(fid);
                    if minimumER > AverageErrorRate
                        minimumER = AverageErrorRate;
                        minRatio = ratio;
                        minx = x;
                        miny = y;
                    end
                end
            end
        end
    end
    fid = fopen('Exp_GFDA_Random_TestOnORL.txt','a+');
    
    str = strcat('MIN ------------ > TrainNum:',num2str(TrainNum),', Ratio:', num2str(minRatio),...
        ', Dim: [',num2str(minx),',',num2str(miny),'], Error rate:', num2str(minimumER), ...
        ', Accuracy:', num2str(1-minimumER), '\r\n\r\n');
    
    fprintf(fid,str);
    fclose(fid);
end
