function [Y] = matrix2tensor(X,I,n)
% Description: This function is reconstruct the high-order tensor which has been
% flatten to a matrix form respect to mode-n
% 
% Arguments:    X                   -The tensor to be matricized;
%               I                   -The dimension of the original tensor 
%               n                   -The mode that we want to flatten the tensor along
%
% Returns:      Y                   -The original tensor which has the mode-n matricization X
%
% see also ipermute, reshape
%
% Author: Aimery Kong    
%    3/10/2010

J = I(n);
K = prod(I)/I(n);
sequence = [];
dim = [];
for i = 1:size(I,2)
    if i ~= n
        sequence = [sequence i];
        dim = [dim I(i)];
    end
end

Y = ipermute(reshape(X,[J dim]),[n sequence]);