function [Y,n] = tensor2matrix(X,n)
% Description: This function is used to flatten a 3-way tensor with respect the mode-n
%
% Arguments:       X                      -The the tensor to be matricized;
%                  n                      -The mode that we want to flatten the tensor along
%                       
% Returns:         Y                      -The matrix form of the tensor X
%                  n                      -The same as the input n.
%
% see also prod, reshape, permute
%
% Author: Aimery Kong    
%    3/10/2010

I = size(X);
J = I(n);
K = prod(I)/I(n);
sequence = [];
for i = 1:size(I,2)
    if i ~= n
        sequence = [sequence i];
    end
end
Y = reshape(permute(X,[n sequence]),J,K);